/* mand1.c */
/* mandelbrot-set-plot
some code taken from 'lcd16gry'
 license: GPL
 */
Byte *LPICF = (Byte *) 0xFFFFFA20;
Byte *LVPW = (Byte *) 0xFFFFFA05;
ULong *LSSA=(ULong *) 0xFFFFFA00;

char *screen;
char penval = 15; 

void pix(int x, int y,char c) {
 int addr=(x>>1)+(y<<4)+(y<<6);
/*80= 64+16 */
/* op-priority-bug << 
  onboardC */
 if (x & 1) {
  screen[addr] &= 0xf0;
  screen[addr] |=c;
 } else {
  screen[addr] &= 0x0f;
  screen[addr] |= c<< 4;
 }
}


DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  EventType e;
  Err error;

  if (cmd == sysAppLaunchCmdNormalLaunch) {

   ULong loc;
  loc =*LSSA;

    screen = MemPtrNew(12800);
MemSet(screen, 12800, 0x00);

    *LPICF |= 0x02;
    *LVPW <<= 2;
    *LSSA =(ULong)screen;

/* draw Mand: */
if(1){ Long cr,ci,a,b,a2,b2;
  int x,y;char col;
 ci=-2<<10;
  for (y=0;y<160;++y){
   cr=-2<<10;
   for (x=0;x<160;++x){
     a=0;b=0;col=0;
    do {
      a2=a*a;b2=b*b;
      a2>>=10;b2>>=10;
      b=((a*b)>>9)+ci;
      a=a2-b2+cr;
   }while((col++<15)&&
               (a2+b2<(4<<10)));
      pix(x,y,col);
      cr+=(3<<10)/160;
    }
    ci+=(3<<10)/160;
  }
}

    do {

      EvtGetEvent(&e, evtWaitForever);

      if (SysHandleEvent(&e))
        continue;

      switch (e.eType) {

      case keyDownEvent:
        switch (e.data.keyDown.chr) {
        case pageDownChr:
          penval++;
          penval &= 15;
          break;
        case pageUpChr:
          penval--;
          penval &= 15;
          break;
        default:
          break;
        }
        break;

      case penDownEvent:
      case penMoveEvent:
        pix(e.screenX, e.screenY, penval);
        break;

      default:
        break;

      }
    } while (e.eType != appStopEvent);


    *LSSA = loc;

    *LVPW >>= 2;
    *LPICF &= 0xFC;

  }
  return 0;

}

