/* xor.c */
/* xorPatt
some code taken from 'lcd16gry'
 license: GPL
 */
Byte *LPICF = (Byte *) 0xFFFFFA20;
Byte *LVPW = (Byte *) 0xFFFFFA05;
ULong *LSSA=(ULong *) 0xFFFFFA00;

char *screen;
char penval = 15; 

void pix(int x, int y,char c) {
 int addr=(x>>1)+(y<<4)+(y<<6);
/*80= 64+16 */
/* op-priority-bug << 
  onboardC */
 if (x & 1) {
  screen[addr] &= 0xf0;
  screen[addr] |=c;
 } else {
  screen[addr] &= 0x0f;
  screen[addr] |= c<< 4;
 }
}


DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  EventType e;
  Err error;

  if (cmd == sysAppLaunchCmdNormalLaunch) {

   ULong loc;
  loc =*LSSA;

    screen = MemPtrNew(12800);
/*MemSet(screen,12800, 0);*/

    *LPICF |= 0x02;
    *LVPW <<= 2;
    *LSSA =(ULong)screen;


if(1){ 
  int x=0,y=0;
  for (y=0;y<160;++y){
    for (x=0;x<160;++x){
      pix(x,y,x^y);
    }
  }
}


    do {

      EvtGetEvent(&e, evtWaitForever);

      if (SysHandleEvent(&e))
        continue;

      switch (e.eType) {

      case keyDownEvent:
        switch (e.data.keyDown.chr) {
        case pageDownChr:
          penval++;
          penval &= 15;
          break;
        case pageUpChr:
          penval--;
          penval &= 15;
          break;
        default:
          break;
        }
        break;

      case penDownEvent:
      case penMoveEvent:
        pix(e.screenX, e.screenY, penval);
        break;

      default:
        break;

      }
    } while (e.eType != appStopEvent);


    *LSSA = loc;

    *LVPW >>= 2;
    *LPICF &= 0xFC;

  }
  return 0;

}

